]> git.saurik.com Git - apt.git/blame - test/integration/framework
be able to set priorities for created test packages
[apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
3# we all like colorful messages
4CERROR="\e[1;31m" # red
5CWARNING="\e[1;33m" # yellow
6CMSG="\e[1;32m" # green
7CINFO="\e[1;96m" # light blue
8CDEBUG="\e[1;94m" # blue
9CNORMAL="\e[0;39m" # default system console color
10CDONE="\e[1;32m" # green
11CPASS="\e[1;32m" # green
12CFAIL="\e[1;31m" # red
13CCMD="\e[1;35m" # pink
14
15msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
18msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25msgtest() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
29
30# enable / disable Debugging
fc89263e
DK
31MSGLEVEL=${MSGLEVEL:-3}
32if [ $MSGLEVEL -le 0 ]; then
33 msgdie() { true; }
34fi
35if [ $MSGLEVEL -le 1 ]; then
36 msgwarn() { true; }
37 msgnwarn() { true; }
38fi
39if [ $MSGLEVEL -le 2 ]; then
40 msgmsg() { true; }
41 msgnmsg() { true; }
39cc8228
DK
42 msgtest() { true; }
43 msgpass() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
44 msgskip() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
45 msgfail() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
fc89263e
DK
46fi
47if [ $MSGLEVEL -le 3 ]; then
48 msginfo() { true; }
49 msgninfo() { true; }
50fi
51if [ $MSGLEVEL -le 4 ]; then
52 msgdebug() { true; }
53 msgndebug() { true; }
54fi
55msgdone() {
56 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
57 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
58 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
59 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
60 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
61 true;
62 else
63 echo "${CDONE}DONE${CNORMAL}" >&2;
64 fi
65}
8d876415
DK
66
67runapt() {
68 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
7d0627b6
DK
69 if [ -f ./aptconfig.conf ]; then
70 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
4b2a4ab8
MV
71 elif [ -f ../aptconfig.conf ]; then
72 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
7d0627b6
DK
73 else
74 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
75 fi
8d876415
DK
76}
77aptconfig() { runapt apt-config $*; }
78aptcache() { runapt apt-cache $*; }
79aptget() { runapt apt-get $*; }
80aptftparchive() { runapt apt-ftparchive $*; }
1f8b2599 81aptkey() { runapt apt-key $*; }
ec7f904e 82aptmark() { runapt apt-mark $*; }
158fda31
DK
83dpkg() {
84 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
85}
b6b5a542
DK
86aptitude() {
87 if [ -f ./aptconfig.conf ]; then
88 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
89 elif [ -f ../aptconfig.conf ]; then
90 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
91 else
92 LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
93 fi
94}
8d876415 95
b720d0bd
DK
96addtrap() {
97 CURRENTTRAP="$CURRENTTRAP $1"
98 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
99}
8d876415
DK
100
101setupenvironment() {
75954ae2 102 TMPWORKINGDIRECTORY=$(mktemp -d)
8f8169ac 103 local TESTDIR=$(readlink -f $(dirname $0))
3cbbda3c 104 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
8f8169ac 105 BUILDDIRECTORY="${TESTDIR}/../../build/bin"
8d876415
DK
106 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
107 local OLDWORKINGDIRECTORY=$(pwd)
b720d0bd 108 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
8d876415 109 cd $TMPWORKINGDIRECTORY
cd725954 110 mkdir rootdir aptarchive keys
8d876415 111 cd rootdir
b29c3712
DK
112 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
113 mkdir -p var/cache var/lib var/log
cffea9af 114 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
2c6baa5a 115 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
8f8169ac
DK
116 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
117 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
118 else
119 touch var/lib/dpkg/status
120 fi
cd725954 121 touch var/lib/dpkg/available
8d876415
DK
122 mkdir -p usr/lib/apt
123 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
124 cd ..
2c6baa5a 125 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
8f8169ac
DK
126 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
127 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 128 fi
4a4ea26c
AM
129 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
130 if [ -f "${TESTDIR}/${SOURCESSFILE}" ]; then
131 cp "${TESTDIR}/${SOURCESSFILE}" aptarchive/Sources
8f8169ac 132 fi
cd725954
DK
133 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
134 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
cffea9af 135 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
94eb3bee 136 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
8d876415
DK
137 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
138 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
f425d4d5 139 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
cffea9af
DK
140 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
141 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
142 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
143 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
144 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
145 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
2c085486 146 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
8d876415
DK
147 export LC_ALL=C
148 msgdone "info"
149}
150
151configarchitecture() {
152 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
153 echo "APT::Architecture \"$1\";" > $CONFFILE
154 shift
155 while [ -n "$1" ]; do
156 echo "APT::Architectures:: \"$1\";" >> $CONFFILE
157 shift
158 done
159}
160
75954ae2 161setupsimplenativepackage() {
ce9864a8
DK
162 local NAME="$1"
163 local ARCH="$2"
164 local VERSION="$3"
165 local RELEASE="${4:-unstable}"
166 local DEPENDENCIES="$5"
167 local DESCRIPTION="$6"
b7899b00
DK
168 local SECTION="${7:-others}"
169 local DISTSECTION
170 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
171 DISTSECTION="main"
172 else
173 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
174 fi
ce9864a8
DK
175 local BUILDDIR=incoming/${NAME}-${VERSION}
176 mkdir -p ${BUILDDIR}/debian/source
177 cd ${BUILDDIR}
178 echo "* most suckless software product ever" > FEATURES
b7899b00
DK
179 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
180 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
ce9864a8
DK
181
182 * Initial release
183
b7899b00
DK
184 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
185 test -e debian/control || echo "Source: $NAME
186Section: $SECTION
ce9864a8
DK
187Priority: optional
188Maintainer: Joe Sixpack <joe@example.org>
189Build-Depends: debhelper (>= 7)
190Standards-Version: 3.9.1
191
875bcb36
DK
192Package: $NAME" > debian/control
193 if [ "$ARCH" = 'all' ]; then
194 echo "Architecture: all" >> debian/control
195 else
196 echo "Architecture: any" >> debian/control
197 fi
ce9864a8
DK
198 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
199 if [ -z "$DESCRIPTION" ]; then
200 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
201 If you find such a package installed on your system,
202 YOU did something horribly wrong! They are autogenerated
203 und used only by testcases for APT and surf no other propose…" >> debian/control
204 else
205 echo "Description: $DESCRIPTION" >> debian/control
206 fi
b7899b00
DK
207 test -e debian/compat || echo "7" > debian/compat
208 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
ce9864a8 209 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
75954ae2
DK
210 cd - > /dev/null
211}
212
213buildsimplenativepackage() {
214 local NAME="$1"
215 local ARCH="$2"
216 local VERSION="$3"
217 local RELEASE="${4:-unstable}"
218 local DEPENDENCIES="$5"
219 local DESCRIPTION="$6"
220 local SECTION="${7:-others}"
d67004e0 221 local PRIORITY="${8:-optional}"
75954ae2
DK
222 local DISTSECTION
223 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
224 DISTSECTION="main"
225 else
226 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
227 fi
5a635ee4 228 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
b761356f 229
18331adf 230 msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}… "
b761356f
DK
231 mkdir -p $BUILDDIR/debian/source
232 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
233 echo "#!/bin/sh
234echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
235
236 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
237 echo "$NAME ($VERSION) $RELEASE; urgency=low
238
239 * Initial release
240
241 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
242 echo "Source: $NAME
243Section: $SECTION
d67004e0 244Priority: $PRIORITY
b761356f
DK
245Maintainer: Joe Sixpack <joe@example.org>
246Standards-Version: 3.9.1
247
875bcb36
DK
248Package: $NAME" > ${BUILDDIR}/debian/control
249 if [ "$ARCH" = 'all' ]; then
250 echo "Architecture: all" >> ${BUILDDIR}/debian/control
251 else
252 echo "Architecture: any" >> ${BUILDDIR}/debian/control
253 fi
b761356f
DK
254 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> ${BUILDDIR}/debian/control
255 if [ -z "$DESCRIPTION" ]; then
256 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
257 If you find such a package installed on your system,
258 YOU did something horribly wrong! They are autogenerated
259 und used only by testcases for APT and surf no other propose…" >> ${BUILDDIR}/debian/control
260 else
261 echo "Description: $DESCRIPTION" >> ${BUILDIR}/debian/control
262 fi
263 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
264 local SRCS="$( (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
b761356f 265 for SRC in $SRCS; do
5a635ee4 266 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
b761356f 267 done
84aa13f4
DK
268
269 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g'); do
270 rm -rf ${BUILDDIR}/debian/tmp
271 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
272 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
273 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
274 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
275 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
276
277 dpkg-deb --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. 2> /dev/null > /dev/null
278 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
279 done
280
13845042
DK
281 mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
282 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
283 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
5a635ee4 284 rm -rf "${BUILDDIR}"
b761356f 285 msgdone "info"
75954ae2
DK
286}
287
288buildpackage() {
289 local BUILDDIR=$1
290 local RELEASE=$2
291 local SECTION=$3
292 msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
293 cd $BUILDDIR
294 if [ "$ARCH" = "all" ]; then
295 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
296 fi
b7899b00
DK
297 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
298 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
5ed56f93 299 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 300 cd - > /dev/null
b7899b00 301 for PKG in $PKGS; do
75954ae2 302 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
b7899b00
DK
303 done
304 for SRC in $SRCS; do
75954ae2 305 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
b7899b00 306 done
cffea9af 307 msgdone "info"
ce9864a8
DK
308}
309
310buildaptarchive() {
ce9864a8
DK
311 if [ -d incoming ]; then
312 buildaptarchivefromincoming $*
313 else
314 buildaptarchivefromfiles $*
315 fi
316}
317
318createaptftparchiveconfig() {
319 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
158fda31
DK
320 if [ -z "$ARCHS" ]; then
321 # the pool is empty, so we will operate on faked packages - let us use the configured archs
322 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
323 fi
ce9864a8
DK
324 echo -n 'Dir {
325 ArchiveDir "' >> ftparchive.conf
326 echo -n $(readlink -f .) >> ftparchive.conf
327 echo -n '";
328 CacheDir "' >> ftparchive.conf
329 echo -n $(readlink -f ..) >> ftparchive.conf
330 echo -n '";
b7899b00
DK
331 FileListDir "' >> ftparchive.conf
332 echo -n $(readlink -f pool/) >> ftparchive.conf
333 echo -n '";
334};
335Default {
bc33e0f0
DK
336 Packages::Compress ". gzip bzip2 lzma xz";
337 Sources::Compress ". gzip bzip2 lzma xz";
338 Contents::Compress ". gzip bzip2 lzma xz";
b7080ced 339 Translation::Compress ". gzip bzip2 lzma xz";
18331adf 340 LongDescription "false";
ce9864a8
DK
341};
342TreeDefault {
343 Directory "pool/";
344 SrcDirectory "pool/";
345};
346APT {
347 FTPArchive {
348 Release {
349 Origin "joesixpack";
350 Label "apttestcases";
351 Suite "unstable";
352 Description "repository with dummy packages";
353 Architectures "' >> ftparchive.conf
354 echo -n "$ARCHS" >> ftparchive.conf
355 echo 'source";
356 };
357 };
358};' >> ftparchive.conf
b7899b00
DK
359 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
360 echo -n 'tree "dists/' >> ftparchive.conf
361 echo -n "$DIST" >> ftparchive.conf
362 echo -n '" {
ce9864a8
DK
363 Architectures "' >> ftparchive.conf
364 echo -n "$ARCHS" >> ftparchive.conf
b7899b00
DK
365 echo -n 'source";
366 FileList "' >> ftparchive.conf
367 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
368 echo -n '";
369 SourceFileList "' >> ftparchive.conf
370 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
371 echo -n '";
372 Sections "' >> ftparchive.conf
373 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
374 echo '";
ce9864a8 375};' >> ftparchive.conf
b7899b00 376 done
ce9864a8
DK
377}
378
379buildaptftparchivedirectorystructure() {
b7899b00
DK
380 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
381 for DIST in $DISTS; do
382 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
383 for SECTION in $SECTIONS; do
384 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
385 for ARCH in $ARCHS; do
386 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
387 done
388 mkdir -p dists/${DIST}/${SECTION}/source
389 mkdir -p dists/${DIST}/${SECTION}/i18n
390 done
ce9864a8 391 done
ce9864a8
DK
392}
393
9b78cda6
DK
394insertpackage() {
395 local RELEASE="$1"
396 local NAME="$2"
397 local ARCH="$3"
398 local VERSION="$4"
399 local DEPENDENCIES="$5"
d67004e0
DK
400 local PRIORITY="${6:-optional}"
401 local ARCHS=""
402 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g'); do
403 if [ "$arch" = "all" ]; then
404 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
405 else
406 ARCHS="$arch"
407 fi
408 for BUILDARCH in $ARCHS; do
409 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
410 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
411 touch aptarchive/dists/${RELEASE}/main/source/Sources
412 local FILE="${PPATH}/Packages"
413 echo "Package: $NAME
414Priority: $PRIORITY
9b78cda6 415Section: other
2c085486 416Installed-Size: 42
9b78cda6 417Maintainer: Joe Sixpack <joe@example.org>
d67004e0 418Architecture: $arch
2c085486 419Version: $VERSION
d67004e0
DK
420Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
421 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
422 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
9b78cda6
DK
423 If you find such a package installed on your system,
424 YOU did something horribly wrong! They are autogenerated
425 und used only by testcases for APT and surf no other propose…
426" >> $FILE
d67004e0 427 done
9b78cda6
DK
428 done
429}
430
dfc2b1be
DK
431insertinstalledpackage() {
432 local NAME="$1"
433 local ARCH="$2"
434 local VERSION="$3"
435 local DEPENDENCIES="$4"
d67004e0 436 local PRIORITY="${5:-optional}"
dfc2b1be 437 local FILE="rootdir/var/lib/dpkg/status"
d67004e0
DK
438 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g'); do
439 echo "Package: $NAME
dfc2b1be 440Status: install ok installed
d67004e0 441Priority: $PRIORITY
dfc2b1be
DK
442Section: other
443Installed-Size: 42
444Maintainer: Joe Sixpack <joe@example.org>
d67004e0 445Architecture: $arch
dfc2b1be 446Version: $VERSION" >> $FILE
d67004e0
DK
447 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
448 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/installed
dfc2b1be
DK
449 If you find such a package installed on your system,
450 YOU did something horribly wrong! They are autogenerated
451 und used only by testcases for APT and surf no other propose…
452" >> $FILE
d67004e0 453 done
dfc2b1be
DK
454}
455
456
ce9864a8 457buildaptarchivefromincoming() {
3cbbda3c 458 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
ce9864a8
DK
459 cd aptarchive
460 [ -e pool ] || ln -s ../incoming pool
461 [ -e ftparchive.conf ] || createaptftparchiveconfig
462 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 463 msgninfo "\tGenerate Packages, Sources and Contents files… "
ce9864a8 464 aptftparchive -qq generate ftparchive.conf
ce9864a8
DK
465 cd - > /dev/null
466 msgdone "info"
9b78cda6 467 generatereleasefiles
ce9864a8
DK
468}
469
470buildaptarchivefromfiles() {
3cbbda3c 471 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
9b78cda6
DK
472 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
473 msgninfo "\t${line} file… "
474 cat ${line} | gzip > ${line}.gz
475 cat ${line} | bzip2 > ${line}.bz2
476 cat ${line} | lzma > ${line}.lzma
b7080ced 477 cat ${line} | xz > ${line}.xz
8d876415 478 msgdone "info"
9b78cda6
DK
479 done
480 generatereleasefiles
481}
482
483generatereleasefiles() {
484 msgninfo "\tGenerate Release files… "
fe0f7911 485 local DATE="${1:-now}"
9b78cda6 486 if [ -e aptarchive/dists ]; then
18331adf
DK
487 for dir in $(find ./aptarchive/dists -mindepth 3 -maxdepth 3 -type d -name 'i18n'); do
488 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Patterns::='Translation-*' > $dir/Index
489 done
9b78cda6 490 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
35faae11 491 local CODENAME="$(echo "$dir" | cut -d'/' -f 4)"
2c085486
DK
492 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Suite="${CODENAME}" -o APT::FTPArchive::Release::Codename="${CODENAME}" | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
493 if [ "$CODENAME" = "experimental" -o "$CODENAME" = "experimental2" ]; then
35faae11
DK
494 sed -i '/^Date: / a\
495NotAutomatic: yes' $dir/Release
496 fi
9b78cda6
DK
497 done
498 else
499 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
8d876415 500 fi
fe0f7911
DK
501 if [ "$DATE" != "now" ]; then
502 for release in $(find ./aptarchive -name 'Release'); do
503 touch -d "$1" $release
504 done
8d876415 505 fi
b7899b00 506 msgdone "info"
8d876415
DK
507}
508
b7899b00
DK
509setupdistsaptarchive() {
510 local APTARCHIVE=$(readlink -f ./aptarchive)
511 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
512 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
513 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
514 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
515 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
516 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
517 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
518 msgdone "info"
519 done
520}
521
522setupflataptarchive() {
ce9864a8 523 local APTARCHIVE=$(readlink -f ./aptarchive)
8d876415
DK
524 if [ -f ${APTARCHIVE}/Packages ]; then
525 msgninfo "\tadd deb sources.list line… "
526 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
527 msgdone "info"
528 else
529 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
530 fi
531 if [ -f ${APTARCHIVE}/Sources ]; then
532 msgninfo "\tadd deb-src sources.list line… "
533 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
534 msgdone "info"
535 else
536 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
537 fi
b7899b00
DK
538}
539
540setupaptarchive() {
541 buildaptarchive
542 if [ -e aptarchive/dists ]; then
543 setupdistsaptarchive
544 else
545 setupflataptarchive
546 fi
f213b6ea 547 signreleasefiles
cd725954 548 msgninfo "\tSync APT's cache with the archive… "
8d876415 549 aptget update -qq
cd725954 550 msgdone "info"
8d876415
DK
551}
552
f213b6ea
DK
553signreleasefiles() {
554 local SIGNER="${1:-Joe Sixpack}"
555 msgninfo "\tSign archive with $SIGNER key… "
556 local SECKEYS=""
557 for KEY in $(find keys/ -name '*.sec'); do
558 SECKEYS="$SECKEYS --secret-keyring $KEY"
559 done
560 local PUBKEYS=""
561 for KEY in $(find keys/ -name '*.pub'); do
562 PUBKEYS="$PUBKEYS --keyring $KEY"
563 done
564 for RELEASE in $(find aptarchive/ -name Release); do
565 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
fe0f7911 566 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
f213b6ea
DK
567 done
568 msgdone "info"
569}
570
571changetowebserver() {
572 if which weborf > /dev/null; then
573 weborf -xb aptarchive/ 2>&1 > /dev/null &
b720d0bd 574 addtrap "kill $!;"
f213b6ea
DK
575 local APTARCHIVE="file://$(readlink -f ./aptarchive)"
576 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
577 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
578 done
579 return 0
580 fi
581 return 1
582}
583
584checkdiff() {
8d876415
DK
585 local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
586 if [ -n "$DIFFTEXT" ]; then
587 echo
588 echo "$DIFFTEXT"
589 return 1
590 else
591 return 0
592 fi
593}
594
75954ae2
DK
595testfileequal() {
596 local FILE="$1"
597 shift
598 msgtest "Test for correctness of file" "$FILE"
599 if [ -z "$*" ]; then
f213b6ea 600 echo -n "" | checkdiff $FILE - && msgpass || msgfail
75954ae2 601 else
f213b6ea 602 echo "$*" | checkdiff $FILE - && msgpass || msgfail
75954ae2
DK
603 fi
604}
605
8d876415
DK
606testequal() {
607 local COMPAREFILE=$(mktemp)
b720d0bd 608 addtrap "rm $COMPAREFILE;"
8d876415
DK
609 echo "$1" > $COMPAREFILE
610 shift
611 msgtest "Test for equality of" "$*"
f213b6ea 612 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
613}
614
685625bd
DK
615testequalor2() {
616 local COMPAREFILE1=$(mktemp)
617 local COMPAREFILE2=$(mktemp)
618 local COMPAREAGAINST=$(mktemp)
b720d0bd 619 addtrap "rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
685625bd
DK
620 echo "$1" > $COMPAREFILE1
621 echo "$2" > $COMPAREFILE2
622 shift 2
623 msgtest "Test for equality OR of" "$*"
624 $* 2>&1 1> $COMPAREAGAINST
f213b6ea
DK
625 (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
626 checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
627 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
628 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
685625bd
DK
629 msgfail )
630}
631
8d876415 632testshowvirtual() {
edc0ef10 633 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
634 local PACKAGE="$1"
635 shift
636 while [ -n "$1" ]; do
637 VIRTUAL="${VIRTUAL}
edc0ef10 638N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
639 PACKAGE="${PACKAGE} $1"
640 shift
641 done
642 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
643 VIRTUAL="${VIRTUAL}
4bec02c2 644N: No packages found"
8d876415 645 local COMPAREFILE=$(mktemp)
b720d0bd 646 addtrap "rm $COMPAREFILE;"
8d876415
DK
647 local ARCH=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
648 eval `apt-config shell ARCH APT::Architecture`
649 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
e8379ba3 650 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
651}
652
653testnopackage() {
654 msgtest "Test for non-existent packages" "apt-cache show $*"
655 local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
656 if [ -n "$SHOWPKG" ]; then
657 echo
658 echo "$SHOWPKG"
659 msgfail
660 return 1
661 fi
662 msgpass
663}
01a6e24c
DK
664
665testdpkginstalled() {
666 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
87bc1c45
DK
667 local PKGS="$(dpkg -l $* | grep '^i' | wc -l)"
668 if [ "$PKGS" != $# ]; then
01a6e24c
DK
669 echo $PKGS
670 dpkg -l $* | grep '^[a-z]'
671 msgfail
672 return 1
673 fi
674 msgpass
675}
676
5cf733e1
DK
677testdpkgnotinstalled() {
678 msgtest "Test for correctly not-installed package(s) with" "dpkg -l $*"
87bc1c45 679 local PKGS="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
01a6e24c
DK
680 if [ "$PKGS" != 0 ]; then
681 echo
682 dpkg -l $* | grep '^[a-z]'
683 msgfail
684 return 1
685 fi
686 msgpass
687}
ec7f904e
DK
688
689testmarkedauto() {
690 local COMPAREFILE=$(mktemp)
691 addtrap "rm $COMPAREFILE;"
692 if [ -n "$1" ]; then
693 msgtest 'Test for correctly marked as auto-installed' "$*"
694 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
695 else
696 msgtest 'Test for correctly marked as auto-installed' 'no package'
697 echo > $COMPAREFILE
698 fi
699 aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
700}